window.Gleam.initSearch([{"doc":"gleamlz_string","title":"gleamlz_string","content":"# GleamLZ_String\r\n### This is a Gleam implementation of the [lz-string](https://github.com/pieroxy/lz-string) compression algorithm\r\n\r\n### Installation\r\n```sh\r\ngleam add TODO:\r\n```\r\n### Usage\r\n```gleam\r\nimport gleamlz_string\r\n \r\npub fn main() {\r\n  let string = &quot;Hello World!&quot;\r\n\r\n  //Uint8Array\r\n  gleamlz_string.compress_to_uint8(string)\r\n  //&lt;&lt;4, 133, 48, 54, 96, 246, 0, 64, 234, 144, 39, 48, 4, 192, 132, 64&gt;&gt;\r\n  gleamlz_string.decompress_from_uint8(&lt;&lt;4, 133, 48, 54, 96, 246, 0, 64, 234, 144, 39, 48, 4, 192, 132, 64&gt;&gt;)\r\n  //&quot;Hello World!\r\n\t\r\n  //Base64\r\n  gleamlz_string.compress_to_base64(string)\r\n  //&quot;BIUwNmD2AEDqkCcwBMCEQA==&quot;\r\n  gleamlz_string.decompress_from_base64(&quot;BIUwNmD2AEDqkCcwBMCEQA==&quot;)\r\n  //&quot;Hello World&quot;\r\n\t\r\n  //URI encoded\r\n  gleamlz_string.compress_to_encoded_uri(string)\r\n  //&quot;BIUwNmD2AEDqkCcwBMCEQA$$&quot;\r\n  gleamlz_string.decompress_from_encoded_uri(&quot;BIUwNmD2AEDqkCcwBMCEQA$$&quot;)\r\n  //&quot;Hello World!&quot;\r\n    \r\n}\r\n```\r\n\r\n### Note\r\n\r\nTODO:\r\n\r\n - [ ] Add `compress_to_utf16`\r\n - [ ] Add tests for `base64` and `encoded_uri`\r\n - [ ] Add tests to automatically compare with the JavaScript version of LZ_String\r\n - [ ] Finish README\r\n - [ ] Add Documentation\r\n\r\n### Docs\r\nTODO\r\n\r\n### Acknowledgements\r\n[Original LZ_String by Pieroxy](https://github.com/pieroxy/lz-string)\r\n\r\nUsed [Michael Shapiro&#39;s elixir verson](https://github.com/koudelka/elixir-lz-string/tree/master) as reference \r\n\r\n### License\r\n[Apache 2.0](./LICENSE)\r\n","url":"index.html"},{"doc":"gleamlz_string","title":"DecompressError","content":"pub type DecompressError {\n  EInvalidInput\n}\n\nEInvalidInput\n\n\nSynonyms:\ngleamlz_string.DecompressError\ngleamlz_string DecompressError","url":"gleamlz_string.html#DecompressError"},{"doc":"gleamlz_string","title":"compress_to_base64","content":"pub fn compress_to_base64(string: String) -&gt; String\n Compress a string into an ASCII base64 encoded representation\n ## Example\n \n let compressed = compress_to_base64(string: &quot;Hello World&quot;)\n \n\nSynonyms:\ngleamlz_string.compress_to_base64\ngleamlz_string compress_to_base64","url":"gleamlz_string.html#compress_to_base64"},{"doc":"gleamlz_string","title":"compress_to_encoded_uri","content":"pub fn compress_to_encoded_uri(string: String) -&gt; String\n Compress a string into ASCII representing the original string with a few changes to make it URI safe\n ## Example\n \n let compressed = compress_to_encoded_uri(string: &quot;Hello World&quot;)\n \n\nSynonyms:\ngleamlz_string.compress_to_encoded_uri\ngleamlz_string compress_to_encoded_uri","url":"gleamlz_string.html#compress_to_encoded_uri"},{"doc":"gleamlz_string","title":"compress_to_uint8","content":"pub fn compress_to_uint8(string: String) -&gt; BitArray\n Compress a string to a BitArray\n ## Example\n \n let compressed = compress_to_uint8(string: &quot;Hello World&quot;)\n \n\nSynonyms:\ngleamlz_string.compress_to_uint8\ngleamlz_string compress_to_uint8","url":"gleamlz_string.html#compress_to_uint8"},{"doc":"gleamlz_string","title":"decompress_from_base64","content":"pub fn decompress_from_base64(\n  base64_string: String,\n) -&gt; Result(String, DecompressError)\n Decompress an lz-string base64 string back to the original UTF16 string\n ## Example\n \n let assert Ok(decompressed) = decompress_from_base64(base64_string: &quot;BYUwNmD2A0AECWsCGBbZtDUzkAA=&quot;)\n \n\nSynonyms:\ngleamlz_string.decompress_from_base64\ngleamlz_string decompress_from_base64","url":"gleamlz_string.html#decompress_from_base64"},{"doc":"gleamlz_string","title":"decompress_from_encoded_uri","content":"pub fn decompress_from_encoded_uri(\n  uri_string: String,\n) -&gt; Result(String, DecompressError)\n Decompress an lz-string URI string back to the original UTF16 string\n ## Example\n \n let assert Ok(decompressed) = decompress_from_encoded_uri(uri_string: &quot;BYUwNmD2A0AECWsCGBbZtDUzkAA$&quot;)\n \n\nSynonyms:\ngleamlz_string.decompress_from_encoded_uri\ngleamlz_string decompress_from_encoded_uri","url":"gleamlz_string.html#decompress_from_encoded_uri"},{"doc":"gleamlz_string","title":"decompress_from_uint8","content":"pub fn decompress_from_uint8(\n  bits: BitArray,\n) -&gt; Result(String, DecompressError)\n Decompress an lz-string BitArray back to the original UTF16 string\n ## Example\n \n let assert Ok(decompressed) = decompress_from_uint8(bits: &lt;&lt;5, 132, 178, 0&gt;&gt;)\n \n\nSynonyms:\ngleamlz_string.decompress_from_uint8\ngleamlz_string decompress_from_uint8","url":"gleamlz_string.html#decompress_from_uint8"},{"doc":"gleamlz_string","title":"gleamlz_string","content":"","url":"gleamlz_string.html"}]);